<template>
  <v-app>
    <v-main>
      <DataTable
        @click:row="clicked"
        :items="items"
        show-expand
        :fields="displayableFields"
        :actions="actions"
        :pagination.sync="pagination"
        :loading="loading"
        @search="search"
        show-select
        v-model="selected"
        item-key="text"
        :events="{
          'update:sort-by': $event => sort({ sortBy: $event }),
          'update:sort-desc': $event => sort({ sortDesc: $event })
        }"
        @update:page="goToPage"
      >
        <template v-slot:top>
          <div>This is content above the actual table</div>
        </template>
        <template v-slot:expanded-item="{ headers, item }">
          <td :colspan="headers.length">{{ item.text }} {{ item.date }}</td>
        </template>
      </DataTable>
    </v-main>
  </v-app>
</template>

<script lang="ts">
import Vue from "vue";
import DataTable from "./components/index.vue";

export default Vue.extend({
  name: "App",
  components: {
    DataTable
  },
  data: () => ({
    selected: [],
    displayableFields: [
      {
        id: "text",
        type: "text",
        label: "Text"
      },
      {
        id: "date",
        type: "date",
        label: "Date",
        format: "DD/MM/YYYY hh:mm:ss"
      },
      {
        id: "currency",
        type: "currency",
        label: "Currency",
        symbol: "USD"
      },
      {
        id: "indicator",
        type: "indicator",
        label: "Indicator"
      },
      {
        id: "dynamic",
        type: "dynamic",
        label: "dynamic",
        method: (item: any) =>
          `<div style="color: red">${item.text} ${item.date || ""}</div>`
      },
      {
        id: "user",
        type: "dynamic",
        label: "async dynamic",
        asyncMethod: async (item: any) => {
          const response = await fetch(
            "https://jsonplaceholder.typicode.com/users/1"
          );
          const user = await response.json();
          return user.name;
        }
      }
    ],
    items: [
      {
        text: "text fielsd",
        currency: 200,
        indicator: "error"
      },
      {
        text: "text field",
        date: "2000-01-01",
        currency: 20,
        indicator: "error"
      }
    ],
    pagination: {},
    actions: [
      {
        title: "Edit",
        method: (item: any) => console.log(item),
        display: "list"
      },
      {
        title: "Delete",
        method: (item: any) => console.log(item),
        display: "menu"
      }
    ],
    dataTable: {
      showExpand: true
    },
    filter: {},
    loading: false
  }),
  methods: {
    search(v: string) {},
    clicked: (item: any) => console.log(item),
    sort({ sortBy, sortDesc }: { sortBy: string[]; sortDesc: boolean[] }) {
      if (sortBy !== undefined) {
        console.log(sortBy[0]);
      }
      if (sortDesc !== undefined) {
        console.log(sortDesc[0]);
      }
    },
    goToPage(pageNumber: number) {
      console.log(pageNumber);
    }
  }
});
</script>
